# Katie

# Copyright 2000-2001 Geoffrey D. Bennett <geoffrey@netcraft.com.au>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA.

package Katie::VOBStore;

use strict;

# TODO: all of this code should be moved into a "whole_copy" manager
# and replaced with something that selects between managers based on
# the element type.  At least it's in its own module now.

# TODO: write an alternate storage manager that uses something apart
# from 'cp' to store revisions (eg. xdelta or even RCS).

# methods:
#   get_size
#   create_element
#   create_branch
#   create_revision
#   construct_revision

sub new {
  shift(@_);
  my($store_dir_s) = @_;
  my($self) = {
    store_dir_s => $store_dir_s,
  };

  return bless $self;
}

sub create_element {
  my($self, $element_id, $branch_id, $revision_id) = @_;

  system("touch $self->{store_dir_s}/$revision_id");
  return 0;
}

sub create_branch {
  my($self, $element_id, $new_branch_id,
     $old_revision_id, $new_revision_id) = @_;

  system("cp $self->{store_dir_s}/$old_revision_id $self->{store_dir_s}/$new_revision_id");
  return 0;
}

sub create_revision {
  my($self, $element_id, $old_revision_id, $new_revision_id, $in_fn) = @_;

  system("cp $in_fn $self->{store_dir_s}/$new_revision_id");
  return 0;
}

sub construct_revision {
  my($self, $element_id, $revision_id, $out_fn) = @_;

  system("cp $self->{store_dir_s}/$revision_id $out_fn");
  return 0;
}

1;
