/* Katie
 *
 * Copyright 2000-2001 Geoffrey D. Bennett <geoffrey@netcraft.com.au>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 */

/* VOBs */
CREATE SEQUENCE vob_id_seq;
GRANT ALL ON vob_id_seq TO katie;
CREATE TABLE vob (
  id    INT PRIMARY KEY DEFAULT nextval('vob_id_seq'),
  name  VARCHAR(40) NOT NULL UNIQUE,
  store VARCHAR(256) NOT NULL,
  uid   INT NOT NULL,
  gid   INT NOT NULL
);
GRANT ALL ON vob TO katie;

CREATE TABLE vob_group (
  vob_id INT NOT NULL,
  gid    INT NOT NULL
);

CREATE UNIQUE INDEX vob_group_vob_id_gid ON vob_group (vob_id, gid);

/* Views */
CREATE SEQUENCE view_id_seq;
GRANT ALL ON view_id_seq TO katie;
CREATE TABLE view (
  id     INT PRIMARY KEY DEFAULT nextval('view_id_seq'),
  vob_id INT NOT NULL,
  name   VARCHAR(40) NOT NULL UNIQUE,
  store  VARCHAR(256) NOT NULL
);
GRANT ALL ON view TO katie;
