# Katie

# Copyright 2000-2002 Geoffrey D. Bennett <geoffrey@netcraft.com.au>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA.

package Katie::File;

use strict;
use Katie::Constants;

require Exporter;

@Katie::File::ISA = qw(Exporter);

@Katie::File::EXPORT = qw(
  read_file
);

sub read_file {
  my($fn) = @_;
  my($fh) = new FileHandle;

  if (-f $fn and -s $fn > MAX_SMALL_FILE_SIZE) {
    warn "$0: Error: $fn seems to be unreasonably large\n";
    return undef;
  }

  if (!$fh->open($fn, "<")) {
    warn "$0: Error: Couldn't open $fn: $!\n";
    return undef;
  }

  local($/) = undef;
  return scalar(<$fh>);
}
