# Katie

# Copyright 2000-2001 Geoffrey D. Bennett <geoffrey@netcraft.com.au>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA.

package Katie::PerlRPC;

use strict;

use Katie::Comm;

sub new {
  shift;
  my($socket) = @_;
  my($self) = { socket => $socket };

  bless($self);

  $self->Katie::Comm::Init();

  return $self;
}

sub read {
  my($self) = @_;

  my $result = eval {
    $self->Katie::Comm::Read()
  };
  if ($@) {
    warn $@;
    return undef;
  }
  return $result;
}

sub write {
  my($self, $msg) = @_;

  eval {
    $self->Katie::Comm::Write($msg);
  };
  warn $@ if $@;
}

1;
